//  $Id: CaptureFileOpenException.java,v 1.2 2008/08/18 05:34:36 esmondpitt Exp $

/***************************************************************************
 * Copyright (C) 2001, Christopher Balcerek                                *
 * Copyright (C) 2008, Esmond Pitt                                         *
 * Distributed under the Mozilla Public License                            *
 *   http://www.mozilla.org/NPL/MPL-1.1.txt                                *
 ***************************************************************************/

package net.sourceforge.jpcap.capture;

/**
 * This exception occurs when a tcpdump-formatted savefile cannot be opened.
 *
 * @author Christopher Balcerek
 * @author Esmond Pitt
 * @version $Revision: 1.2 $
 * @lastModifiedBy $Author: esmondpitt $
 * @lastModifiedAt $Date: 2008/08/18 05:34:36 $
 */
public class CaptureFileOpenException extends JpcapException
{
  /**
   * Create a new invalid capture file exception.
   */
  public CaptureFileOpenException(String message) { 
    super(message);
  }

  /**
   * Create a new invalid capture file exception.
   */
  public CaptureFileOpenException(Throwable detail) { 
    super(detail);
  }


  private static final String _rcsId = 
    "$Id: CaptureFileOpenException.java,v 1.2 2008/08/18 05:34:36 esmondpitt Exp $";
}
