/*
 * StatisticsListener.java
 *
 * Created on 22 May 2008, 15:38
 *
 * Copyright (C) 2008, Esmond Pitt                                         *
 * Distributed under the Mozilla Public License                            *
 *   http://www.mozilla.org/NPL/MPL-1.1.txt                                *
 */

package net.sourceforge.jpcap.capture;

import java.util.EventListener;

/**
 * StatisticsListener is the callback that is used when a capture device is in
 * {@link JWinPcap.CaptureMode#Statistical} mode.
 *
 * @see JWinPcap.CaptureMode
 * @see JWinPcap#setCaptureMode
 * @see JWinPcap#addStatisticsListener
 * @see JWinPcap#removeStatisticsListener
 * @see <a href="http://www.winpcap.org/docs/docs_40_2/html/group__wpcap__tut9.html">
 * Gathering Statistics on the network traffic</a>
 *
 * @author Esmond Pitt
 * @version $Revision: 1.1 $
 */
public interface StatisticsListener extends EventListener
{
	/**
	 * Handle a statistics event.
	 * @param event StatisticsEvent
	 */
	void	statisticsArrived(StatisticsEvent event);
}
