package net.sourceforge.jpcap.util;

import net.sourceforge.jpcap.net.TCPPacket;

public class TCPSession {

	private boolean SYN = false;
	private boolean Client_RST_FINACK = false;
	private boolean Server_RST_FINACK = false;
	private int srcPort = -1;
	private int dstPort = -1;
	private int srcIP = -1;
	private int dstIP = -1;

	private int count = 0;

	public TCPSession() {
	}

	public TCPSession(TCPPacket e) {
		add(e);
	}

	public void incr() {
		count++;
	}

	public int getPacketCount() {
		return count;
	}

	public boolean isSYN() {
		return SYN;
	}

	public boolean isClosed() {
		return Client_RST_FINACK && Server_RST_FINACK;
	}

	public boolean isClientClosed() {
		return Client_RST_FINACK;
	}

	public boolean isServerClosed() {
		return Server_RST_FINACK;
	}

	public int getSrcPort() {
		return srcPort;
	}

	public int getDstPort() {
		return dstPort;
	}

	public int getSrcIP() {
		return srcIP;
	}

	public int getDstIP() {
		return dstIP;
	}

	public boolean matchSession(TCPPacket e) {
		//		if(e.getTCPSourcePort()==44564)

		if (srcPort == e.getSourcePort()
				&& dstPort == e.getDestinationPort()
				&& srcIP == Convert.ipToInt(e.getSourceInetAddress()
						.getHostAddress())
				&& dstIP == Convert.ipToInt(e.getDestinationInetAddress()
						.getHostAddress()))
			return true;
		else if (dstPort == e.getSourcePort()
				&& srcPort == e.getDestinationPort()
				&& dstIP == Convert.ipToInt(e.getSourceInetAddress()
						.getHostAddress())
				&& srcIP == Convert.ipToInt(e.getDestinationInetAddress()
						.getHostAddress()))
			return true;

		return false;
	}

	public boolean add(TCPPacket e) {
		int srcPortTmp = e.getSourcePort();
		int dstPortTmp = e.getDestinationPort();
		int srcIPTmp = Convert.ipToInt(e.getSourceInetAddress()
				.getHostAddress());
		int dstIPTmp = Convert.ipToInt(e.getDestinationInetAddress()
				.getHostAddress());

		if (srcPort == -1) {
			srcPort = srcPortTmp;
			dstPort = dstPortTmp;
			srcIP = srcIPTmp;
			dstIP = dstIPTmp;
		} else if ((srcPort != srcPortTmp || srcIP != srcIPTmp
				|| dstPort != dstPortTmp || dstIP != dstIPTmp)
				&& (srcPort != dstPortTmp || dstPort != srcPortTmp
						|| srcIP != dstIPTmp || dstIP != srcIPTmp)) {
			return false;
		}

		if (e.isSyn()) { // Ok we have a SYN, is this a new session
			SYN = true;
		} else if (e.isRst() || (e.isFin() && e.isAck())
				|| (e.isAck() && Client_RST_FINACK)) {
			if (srcPort == srcPortTmp && dstPort == dstPortTmp
					&& srcIP == srcIPTmp && dstIP == dstIPTmp)
				Client_RST_FINACK = true;
			else if (dstPort == srcPortTmp && srcPort == dstPortTmp
					&& dstIP == srcIPTmp && srcIP == dstIPTmp)
				Server_RST_FINACK = true;
		}
		incr();
		return true;
	}
}
